#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import os
import json
from xml.etree.ElementTree import *
from optparse import OptionParser

#### main method###
if __name__ == "__main__":
    myusage = "%prog [-i INPUT] [-o OUTPUT]"
    psr = OptionParser(usage=myusage)
    psr.add_option("-i", "--input"  , action="store", type="string", dest="input", default="", metavar="INPUT", help="input filename")
    psr.add_option("-o", "--output"  , action="store", type="string", dest="output"   , default="",   metavar="OUTPUT"       , help="output filename")
    (opts, args) = psr.parse_args(sys.argv)

    inputFilePath=os.path.abspath(opts.input.rstrip("\""))
    outputFilePath=os.path.abspath(opts.output.rstrip("\""))

    tree = parse(inputFilePath)
    elem = tree.getroot()

    roottag=elem.tag[elem.tag.index("}")+1:len(elem.tag)]
    if roottag == "Error" :
        sys.exit(1)

    def iterparent(elem):
        for parent in elem.getiterator():
            for child in parent:
                yield parent, child

    tmplist=[]
    operationlist=[]
    getServiceName=0
    getSubscription=0
    loop=1
    operationParam=""
    continuationToken=""
    for p,c in iterparent(elem):
        parenttag=p.tag[p.tag.index("}")+1:len(p.tag)]
        childtag=c.tag[c.tag.index("}")+1:len(c.tag)]

        if childtag == "OperationId" :
            tmplist.append("OperationId" + ":" + c.text)

        if parenttag == "SubscriptionOperation" and childtag == "OperationObjectId" :
            tmplist.append("OperationObjectId" + ":" + c.text)

        if childtag == "OperationName" :
            tmplist.append("OperationName" + ":" + c.text)

        if parenttag == "OperationParameter" :
            if childtag == "Name" :
                operationParam = operationParam + c.text + ":"
            if childtag == "Value" :
                operationParam = operationParam + str(c.text)
                tmplist.append(operationParam)
                operationParam=""

        if parenttag == "OperationCaller" :
            if childtag == "UsedServiceManagementApi" :
                tmplist.append("UsedServiceManagementApi:" + c.text)
            elif childtag == "UserEmailAddress" :
                tmplist.append("UserEmailAddress:" + c.text)
            elif childtag == "SubscriptionCertificateThumbprint" :
                tmplist.append("SubscriptionCertificateThumbprint:" + str(c.text))
            elif childtag == "ClientIP" :
                tmplist.append("ClientIP:" + c.text)

        if parenttag == "OperationStatus" :
            if childtag == "ID" :
                tmplist.append("ID:" + c.text)
            elif childtag == "Status" :
                tmplist.append("Status:" + c.text)
            elif childtag == "Status" :
                tmplist.append("Status:" + c.text)


        if childtag == "OperationStartedTime" :
            tmplist.append("OperationStartedTime" + ":" + c.text)

        if childtag == "OperationCompletedTime" :
            tmplist.append("OperationCompletedTime" + ":" + c.text)

        if childtag == "OperationKind" :
            tmplist.append("OperationKind" + ":" + c.text)

        if childtag == "ContinuationToken":
            continuationToken = c.text

        if parenttag == "OperationStatus" and childtag == "HttpStatusCode" :
            loop=0
            operationlist.append(tmplist)
            tmplist=[]

    try:
        outputFilePath = os.path.abspath(opts.output.rstrip("\""))
        f = open(outputFilePath,"a")
        for logstr in operationlist:
            outputlist=json.dumps(logstr, sort_keys=True, indent=4)
            string=""
            flag=True
            for s in outputlist:
                if flag:
                    if s != " ":
                        string = string + s
                        if s =="\"":
                            flag=False
                else:
                    string = string + s
                    if s =="\"":
                        flag=True
            string = string.replace('\n','')
            f.write(string + "\n")
    except Exception, e:
        print str(e)
        sys.exit(1)
    finally:
        f.close()
    print(continuationToken)
    sys.exit(0)
